/****************************************************************************/
/* ALBERT:   an Adaptive multi Level finite element toolbox using           */
/*           Bisectioning refinement and Error control by Residual          */
/*           Techniques                                                     */
/*                                                                          */
/* file:     bas_fct.c                                                      */
/*                                                                          */
/*                                                                          */
/* description:  Lagrange basis functions up to order 4 in 2 and 3          */
/*               dimensions                                                 */
/*                                                                          */
/*               includes lagrange_0.c - lagrange_4.c in 2d and 3d          */
/* history:                                                                 */
/*                                                                          */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/*        authors: Alfred Schmidt and Kunibert G. Siebert                   */
/*                 Institut f"ur Angewandte Mathematik                      */
/*                 Albert-Ludwigs-Universit"at Freiburg                     */
/*                 Hermann-Herder-Str. 10                                   */
/*                 79104 Freiburg                                           */
/*                 Germany                                                  */
/*                                                                          */
/*        email:   alfred,kunibert@mathematik.uni-freiburg.de               */
/*                                                                          */
/*     (c) by A. Schmidt and K.G. Siebert (1996-1999)                       */
/*                                                                          */
/****************************************************************************/
#include "albert.h"

/****************************************************************************/
/*  Lagrangian basisfunctions of order 0-4; these                           */
/*  functions are evaluated in barycentric coordinates; the derivatives     */
/*  are those corresponding to these barycentric coordinates.               */
/****************************************************************************/

#include "lagrange_0.c"
#include "lagrange_1.c"
#include "lagrange_2.c"
#include "lagrange_3.c"
#include "lagrange_4.c"

#include "bas_fct_common.c"
