#include <albert.h>

static void refine_global(MESH *mesh, int mark);
static GRAPH_WINDOW  win;

int main(int argc, char **argv)
{
  FUNCNAME("main");
  MESH         *mesh;
  int          n_refine;

/****************************************************************************/
/*  first of all, init parameters of the init file                          */
/****************************************************************************/

  init_parameters(1, "INIT/init.dat");
  
/****************************************************************************/
/*  get a mesh, and                                                         */
/*  read the macro triangulation from file                                  */
/****************************************************************************/

  mesh = GET_MESH("my first mesh", nil, nil);
  mesh->preserve_coarse_dofs = 0;
  read_macro(mesh, "Macro/macro_big.stand", nil);

  win = graph_open_window("ALBERT", "300x300+0+0", nil, mesh);

  n_refine = 2;
  GET_PARAMETER(2, "global refinements", "%d", &n_refine);

  refine_global(mesh, n_refine*DIM);

  graph_clear_window(win, rgb_black);
  graph_mesh(win, mesh, rgb_white, 0);

  WAIT;
}


/****************************************************************************/
/*  an example for global refinement                                        */
/****************************************************************************/

static int refine_global_mark;

static void refine_global_fct(const EL_INFO *el_info)
{
  FUNCNAME("refine_global_fct");

  el_info->el->mark = refine_global_mark;
}

static void refine_global(MESH *mesh, int mark)
{
  FUNCNAME("refine_global");

  refine_global_mark = mark;

  mesh_traverse(mesh, -1, CALL_LEAF_EL, refine_global_fct);
  graph_clear_window(win, rgb_black);
  graph_mesh(win, mesh, rgb_white, GRAPH_MESH_ELEMENT_MARK);
  WAIT;

  refine(mesh);
}
