#include "oem.h"
#include "cblas.h"

/*--------------------------------------------------------------------------*/
/*  library of Orthogonal Error Methods                                     */
/*                                                                          */
/*  most routines are the C-version of OFM-lib by Willy Doerfler            */
/*     http://www.mathematik.uni-kl.de/~doerfler/ofmlib.ps                  */
/*                                                                          */
/*  author: Kunibert G. Siebert                                             */
/*          Institut f"ur Angewandte Mathematik                             */
/*          Albert-Ludwigs-Universit"at Freiburg                            */
/*          Hermann-Herder-Str. 10                                          */
/*          79104 Freiburg                                                  */
/*          Germany                                                         */
/*                                                                          */
/* email:  kunibert@mathematik.uni-freiburg.de                              */
/*                                                                          */
/* (c) by K.G. Siebert (2000)                                               */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/*  functions for printing information (file info.c)                        */
/*--------------------------------------------------------------------------*/

void start_info(const char *, OEM_DATA *);
void break_info(const char *, OEM_DATA *, const char *, int, REAL, REAL *,
		WORKSPACE *);
int  solve_info(const char *, OEM_DATA *, int, REAL, REAL *, WORKSPACE *);

#define START_INFO(oem)  start_info(funcName, oem)
#define BREAK_INFO(oem,st,it,res,ores,ws)\
  break_info(funcName,oem,st,it,res,ores,ws)
#define SOLVE_INFO(oem,it,res,ores,ws) solve_info(funcName,oem,it,res,ores,ws)

WORKSPACE *check_workspace(const char *, const char *, int, size_t, 
			   WORKSPACE *);
void free_oem_workspace(WORKSPACE *ws, OEM_DATA *oem);
#define CHECK_WORKSPACE(size,ws)\
  check_workspace(funcName,__FILE__,__LINE__,size,ws)
